/**
 * Ravimoshark Contract API
 * This is an API to interact with Ravimoshark contracts database. # Introduction This API allow to create, modify and delete contracts and machines. It also interacts with machines imported from SAGE database. # User Authentication This API does not contain any kind of user validation but It request to have a valid authentication user to interact with it. For more information about user Authentication, please refer to [Ravimoshark User Authentication](https://ravimoshark.com/back/apis/auth/latest).
 *
 * OpenAPI spec version: 1.0.0
 * Contact: dev@ravimoshark.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */ 
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Contracts } from '../model/contracts';
import { Deleted } from '../model/deleted';
import { InlineResponse200 } from '../model/inlineResponse200';
import { RefContract } from '../model/refContract';
import { Configuration } from '../configuration';
import { ContractsServiceInterface } from './contracts.serviceInterface';
export declare class ContractsService implements ContractsServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Add one contract.
     * Add one contract.
     * @param body
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addContract(body?: Contracts, observe?: 'body', reportProgress?: boolean): Observable<Contracts>;
    addContract(body?: Contracts, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Contracts>>;
    addContract(body?: Contracts, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Contracts>>;
    /**
     * Delete one contract.
     * Delete one contract.
     * @param refContract id to delete or search
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    deleteContract(refContract: number, observe?: 'body', reportProgress?: boolean): Observable<RefContract>;
    deleteContract(refContract: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<RefContract>>;
    deleteContract(refContract: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<RefContract>>;
    /**
     * Edit one contract.
     * Edit one contract.
     * @param body
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    editContract(body?: Contracts, observe?: 'body', reportProgress?: boolean): Observable<Contracts>;
    editContract(body?: Contracts, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Contracts>>;
    editContract(body?: Contracts, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Contracts>>;
    /**
     * Get one contract.
     * Get one contract.
     * @param refContract id to delete or search
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getContractById(refContract: number, deleted?: Deleted, observe?: 'body', reportProgress?: boolean): Observable<Contracts>;
    getContractById(refContract: number, deleted?: Deleted, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Contracts>>;
    getContractById(refContract: number, deleted?: Deleted, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Contracts>>;
    /**
     * Get all contracts.
     * Get all contracts.
     * @param SkipParam number of item to skip
     * @param limit max records to return
     * @param orderBy order by property.
     * @param filterBy filter data.
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param metadata If metadata is needed (for pagination controls)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getContracts(SkipParam: number, limit: number, orderBy?: string, filterBy?: string, deleted?: Deleted, metadata?: boolean, observe?: 'body', reportProgress?: boolean): Observable<InlineResponse200>;
    getContracts(SkipParam: number, limit: number, orderBy?: string, filterBy?: string, deleted?: Deleted, metadata?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<InlineResponse200>>;
    getContracts(SkipParam: number, limit: number, orderBy?: string, filterBy?: string, deleted?: Deleted, metadata?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<InlineResponse200>>;
}
