/**
 * Ravimoshark Contract API
 * This is an API to interact with Ravimoshark contracts database. # Introduction This API allow to create, modify and delete contracts and machines. It also interacts with machines imported from SAGE database. # User Authentication This API does not contain any kind of user validation but It request to have a valid authentication user to interact with it. For more information about user Authentication, please refer to [Ravimoshark User Authentication](https://ravimoshark.com/back/apis/auth/latest).
 *
 * OpenAPI spec version: 1.0.0
 * Contact: dev@ravimoshark.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */ 
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Deleted } from '../model/deleted';
import { IdInteger } from '../model/idInteger';
import { ImportedMachines } from '../model/importedMachines';
import { InlineResponse2001 } from '../model/inlineResponse2001';
import { Machines } from '../model/machines';
import { Configuration } from '../configuration';
import { ImportedMachinesServiceInterface } from './importedMachines.serviceInterface';
export declare class ImportedMachinesService implements ImportedMachinesServiceInterface {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm;
    /**
     * Add one imported Machine.
     * Add one imported Machine.
     * @param body
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    addImportedMachine(body?: ImportedMachines, observe?: 'body', reportProgress?: boolean): Observable<ImportedMachines>;
    addImportedMachine(body?: ImportedMachines, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ImportedMachines>>;
    addImportedMachine(body?: ImportedMachines, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ImportedMachines>>;
    /**
     * Delete one imported Machine.
     * Delete one imported Machine.
     * @param id id to delete or search
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    deleteImportedMachine(id: number, observe?: 'body', reportProgress?: boolean): Observable<IdInteger>;
    deleteImportedMachine(id: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<IdInteger>>;
    deleteImportedMachine(id: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<IdInteger>>;
    /**
     * Edit one imported Machine.
     * Edit one imported Machine.
     * @param body
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    editImportedMachine(body?: ImportedMachines, observe?: 'body', reportProgress?: boolean): Observable<ImportedMachines>;
    editImportedMachine(body?: ImportedMachines, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ImportedMachines>>;
    editImportedMachine(body?: ImportedMachines, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ImportedMachines>>;
    /**
     * Get one imported Machine.
     * Get one imported Machine.
     * @param id id to delete or search
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getImportedMachineById(id: number, deleted?: Deleted, observe?: 'body', reportProgress?: boolean): Observable<Machines>;
    getImportedMachineById(id: number, deleted?: Deleted, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Machines>>;
    getImportedMachineById(id: number, deleted?: Deleted, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Machines>>;
    /**
     * Get all imported Machines.
     * Get all imported Machines.
     * @param SkipParam number of item to skip
     * @param limit max records to return
     * @param orderBy order by property.
     * @param filterBy filter data.
     * @param deleted Get all, deleted, not deleted data. Default not deleted.
     * @param metadata If metadata is needed (for pagination controls)
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    getImportedMachines(SkipParam: number, limit: number, orderBy?: string, filterBy?: string, deleted?: Deleted, metadata?: boolean, observe?: 'body', reportProgress?: boolean): Observable<InlineResponse2001>;
    getImportedMachines(SkipParam: number, limit: number, orderBy?: string, filterBy?: string, deleted?: Deleted, metadata?: boolean, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<InlineResponse2001>>;
    getImportedMachines(SkipParam: number, limit: number, orderBy?: string, filterBy?: string, deleted?: Deleted, metadata?: boolean, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<InlineResponse2001>>;
}
